
tmin=input('enter minimum time slice [default 0]:  ');
if (isempty(tmin))
    tmin = 0;
endif

tmax=input('enter maximum time slice [default 10000000]:  ');
if (isempty(tmax))
    tmax = 10000000;
endif

tpause = input ('enter pause time [default 1]:  ');
if (isempty(tpause))
    tpause = 1;
endif


pscale = input ('enter super particle size [default 1e4]:  ');
if (isempty(pscale))
    pscale = 1e4;
endif

if (tmin < tmax)
    tinc = 1;
else
    tinc = -1;
endif

z = 0:-mm:-2.0*m;
x = y = 0*z;
xlabel('Position in 1.85m guide (m)');
ylabel('n {/Symbol l}^{3}');
title('Degeneracy Regime:  Is It There Yet?');

for t=tmin:tinc:tmax;
    Tx = ointerp(iid, t, 0, x, y, z);
    Ty = ointerp(iid, t, 1, x, y, z);
    Tz = ointerp(iid, t, 2, x, y, z);
    D  = ointerp(iid, t, 3, x, y, z) * pscale;
    Tavg = (Tx+Ty+Tz)/3;
    L = sqrt (h^2 ./ (87*amu*3*K_B*Tavg));

    title(sprintf('Degeneracy Regime:  Is It There Yet?\n%g ms',t));
    %plot(z,Tx,'g-;Tx;', z,Ty,'b-;Ty;', z,Tz,'r-;Tz;', z, (Tx+Ty+Tz)/3,'c-;Tavg;');
    plot(-z,D.*L.^3,';;')
    pause(tpause);
end
