%  Exam 3 -- Problem 3
%  Bound states of Harmonic Oscillator
%  B-splines

hold off
clear

lstart=input(' Enter starting lambda for the scan: ');
lend=input(' Enter ending lambda for the scan: ');
nlam=input('Enter the number of lambdas to look at: ');
plotit=input('Should I plot the psi functions? [1,0]: ');

% set the stepsize in lambda
dl = (lend-lstart)/nlam;

% lambda scan loop
%for p=1:nlam+1
p=1;for lambda = [3.80814] %[7.48436] %[1.0615436] 
% lambda = lstart + (p-1)*dl;
  lplot(p) = lambda;
  
  % define the spline grid
  delta=.1;
  xmin=-5;xmax=5;
  xn=xmin-.5*delta:delta:xmax;
  
  % get the number of finite elements
  n=round((xmax-xmin)/delta) +1;
  
  % define the right-hand side functions
  rodd=xn.*exp((-(xn).^2));
  reven=exp((-xn.^2));
  
  % set the coefficients for the first point
  cn(1,2)=2/3;
  cn(1,3)=1/6;
  yn(1)=0;
  
  % set the coefficients for the last point
  cn(n,1)=2/3;
  cn(n,2)=1/6;
  yn(n)=0;
  
  % load the coefficients for the interior points
  for m=2:n-1;
     cn(m,1)=1/delta^2 + (lambda-xn(m)^4)/6;
     cn(m,2)=-2/delta^2 + (lambda-xn(m)^4)*2/3;
     cn(m,3)=1/delta^2  + (lambda-xn(m)^4)/6;
  end
  
  
  % make the right-hand side
  
  % odd modes
  yn(2:n-1)=rodd(2:n-1);
  yn(1)=0;yn(n)=0;
  
  % even modes
  %yn(2:n-1)=reven(2:n-1);
  %yn(1)=0;yn(n)=0;
  
  
  % solve for the an's
  an=tri_ge(cn,yn);
  
  % load a sort of central an value to look for singular solutions
  aplot(p) = an(fix(n*.6));
  
  %make a plot of u if you want
  dx=delta/10;
  x=xmin:dx:xmax;
  f=0*x;
  
  for m=1:n
  
   f = f + an(m)*bspline(m-.5,x,xmin,delta);
  end

  %subplot(211)
  if(plotit==1)
  %gset output '|lpr -Pfermi'
  %gset terminal post color
  xlabel('X'); ylabel('Psi')
  title(sprintf('Psi for even eigs , lambda=%f',lambda));
  plot(x,f.*conj(f))
  hold on
  %gset output
  %gset terminal x11
  endif
end

if(plotit==1)
  hold off
  pause
end

% plot the random an vs. lambda

%subplot(212)
semilogy(lplot,(aplot).^2)
%hold on

%plot(lplot,aplot)
%hold on
%plot(lplot,0*lplot)

%pause

%semilogy(lplot,1./((aplot).^2))
