% opens a field file to extract the field
% Note that the field file is formatted to be used as surface plots in gnuplot
% (as long as it is only 2D data)
%
% Usage:
% plotcount = plot3dfile(filename)
%
% returns plotcount === number of plots in file
%
function plotcount = plot3dfile(filename)
    global use_plplot_state
    if (!exist("use_plplot_state") || !strcmp(use_plplot_state, "on") )
	warning ("pl plot needs to first be loaded\n");
	plotcount = 0;
	return;
    endif
    fid = fopen(filename,'r');

    plotcount = 0;
    vcount = 0;
    delay = 1e6 * input('enter delay:  ');
    setviewwait = input('enter keep view period[default -1(very long)]:  ');
    if (isempty(setviewwait))
	setviewwait = -1;
    endif
    neednewview = setviewwait;

    skipframe = input('frame increment[default 1]:  ');
    if (isempty(skipframe))
	skipframe = -1;
    endif
    nskipframe = skipframe;

    while ( isstr(line = fgetl(fid)) || line != -1)
	pound = index(line,'#');
	if (pound != 0)
	    line = substr(line,1,pound);
	endif
	[vertex count] = sscanf(line, '%f %f %f');

	if (count != 3 && vcount > 0 && skipframe>0)
	    skipframe--;
	    vcount = 0;
	    continue;
	elseif (count == 3)
	    surf(++vcount,:) = vertex';
	elseif (vcount > 0)
	    skipframe = nskipframe;
	    plotcount++;
	    % time to plot
	    %meshc(x,y,z);
	    plot3(surf(1:vcount,1),surf(1:vcount,2),surf(1:vcount,3),'r*');
	    if (setviewwait>-1)
		if (neednewview<1)
		    set_view("plot3", surf(1:vcount,1),surf(1:vcount,2),surf(1:vcount,3),'r*');
		    if (isempty(rst = input('set more views later?[default yes(0==no,-1==change period)]:  ')))
			neednewview = setviewwait;
		    elseif (rst == -1)
			setviewwait = input('enter keep view period[default -1(very long)]:  ');
			if (isempty(setviewwait))
			    setviewwait = -1;
			endif
			neednewview = setviewwait;
		    else
			setviewwait = -1;
		    endif
		else
		    neednewview--;
		endif
	    endif
	    usleep( delay );
	    %clear surf;
	    vcount = 0;
	endif
    endwhile

    fclose(fid);
end %function
